<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\License\JWT\Namshi\JOSE\Signer\SecLib;


use Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\License\JWT\Namshi\JOSE\Signer\SignerInterface;
//use InvalidArgumentException;
use Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\License\JWT\Namshi\JOSE\Exceptions\InvalidKeyException;

abstract class PublicKey implements SignerInterface
{
    protected $encryptionAlgorithm;

    /**
     * {@inheritdoc}
     */
    public function sign($input, $key, $password = null)
    {
        if ($password) {
            $this->encryptionAlgorithm->setPassword($password);
        }

        if (!$this->encryptionAlgorithm->loadKey($key)) {
            throw new InvalidKeyException('Invalid key supplied.');
        }

        return $this->encryptionAlgorithm->sign($input);
    }

    /**
     * {@inheritdoc}
     */
    public function verify($key, $signature, $input)
    {
        if (!$this->encryptionAlgorithm->loadKey($key)) {
            throw new InvalidKeyException('Invalid key supplied.');
        }

        return $this->encryptionAlgorithm->verify($input, $signature);
    }
}
