({
    extendsFrom: 'AvatarField',

    _render: function() {
        this._super("_render");

        if(!_.isUndefined(this.$('img'))){
            this.$('img').css('border', '0');
            this.$('img').css('border-radius', '0');
        }

        this._addBrokenImageHandler();
    },

    isImageFromRelate: function(){
        return (!_.isEmpty(this.def['id_name']) && !_.isEmpty(this.def['module']) && !_.isEmpty(this.def['rname'])) &&
            (!_.isEmpty(this.value) || !_.isEmpty(this.def['def_image_url']));
    },

    buildUrlFromRelateImage: function(options) {
        if(_.isEmpty(this.model.get(this.name))){
            return this.def['def_image_url'];
        }
        var id = this.model.get(this.def.id_name);
        return app.api.buildFileURL({
            module: this.def.module,
            id: id,
            field: this.def.rname
        }, options) + "&_hash=" + this.model.get('date_modified');
    },

    bindDataChange: function() {
        if (this.model) {
            this.model.on("change:" + this.name, function(model, value) {
                this.render();
            }, this);
        }
    },

    format: function(value) {
        if(this.isImageFromRelate()){
            value = this.buildUrlFromRelateImage();
        }else {
            if (value) {
                value = this.buildUrl() + "&_hash=" + value;
            }
        }
        return value;
    },

    _addBrokenImageHandler: function() {
        this.$('img').on('error', _.bind(function(event) {
            var $brokenImg = $(event.currentTarget);
            $brokenImg.attr('src', 'custom/PxRoutines/NeedToDoViewer/Images/broken_image_icon.png');
        }, this));
    },

    _loadTemplate: function() {
        if(this.action == 'detail') {
            app.view.Field.prototype._loadTemplate.call(this);
        }else{
            this._super("_loadTemplate");
        }
    }

})
