({
    extendsFrom: "ListBottomView",

    /**
     * Retrieving the next page records by pagination plugin.
     *
     * Please see the {@link app.plugins.Pagination#getNextPagination}
     * for detail.
     */
    showMoreRecords: function() {
        if (!this.paginationComponent) {
            return;
        }

        var options = {},
            paginationFunction = _.bind(function(options){
                options = options || {};
                options.success = _.bind(function() {
                    this.context.trigger('paginate');
                    this.render();
                    this.refreshNtdvStatistics();
                }, this);

                this.paginationComponent.getNextPagination(options);
                this.render();
            }, this);

        var component = this.layout.getComponent('need-to-do-events-dashlet');
        if(component){
            options = _.extend(options, component.getCollectionOptions());
            if(component.needsAdditionalLoadingForLastGroup()){
                component.downloadAllRecordsPerGroup(paginationFunction, options);
            }else{
                paginationFunction(options);
            }

        }else{
            paginationFunction();
        }

    },

    refreshNtdvStatistics: function(){
        var component = this.layout.getComponent('need-to-do-events-dashlet');
        if(component){
            component.triggerNeedToDoAmountRefresh();
        }
    },

})
